/*
 *  AApplyTextFactory.h
 *  Keyboard Maestro
 *
 *  Created by Peter N Lewis on Thu 15 May 2008.
 *  Copyright (c) 2008 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"
#import "ClipboardTarget.h"

class AApplyTextFactory
	:	public HBaseAction
{

private:

	ClipboardTarget					mTarget;
	CFContainer<CFStringRef>		mPath = CFSTR("");

public:

    AApplyTextFactory() = default;
	AApplyTextFactory( const AApplyTextFactory& inAction ) = default;
    virtual ~AApplyTextFactory() = default;

	virtual AApplyTextFactory*		Clone() const { return new AApplyTextFactory( *this ); }
	virtual AApplyTextFactory*		Create() const { return new AApplyTextFactory(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kApplyTextFactory; }
	virtual	CFStringRef				CopyActionDescriptionString() const;
	
	CFStringRef						CopyPath() const { return mPath->Copy(); }
	NSString*						GetPath() const { return mPath->GetNS(); }
	void							SetPath( CFStringRef path ) { mPath = path->Copy(); }

	NSString*						GetGenericNamedClipboardUID() const { return mTarget.GetGenericNamedClipboardUID(); }
	void							SetGenericNamedClipboardUID( NSString* inUID ) { mTarget.SetGenericNamedClipboardUID( inUID ); }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues() { mTarget.UpdateToDefaultValues(); }
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
};

