/*
 *  AClipboardHistorySwitcher.cpp
 *  Keyboard Maestro
 *
 *  Created by Peter N Lewis on Mon 19 May 2008.
 *  Copyright (c) 2008 Stairways Software. All rights reserved.
 */

#import "AClipboardHistorySwitcher.h"
#import "XClipboardDataSet.h"
#import "SystemDefinedKeys.h"

#if KMF_IS_ENGINE
#import "ClipboardSwitcherWindowController.h"
#import "UCGRemoteControl.h"
#import "MMacroDomain.h"
#import "KMNotifications.h"
#import "XClipboardHistory.h"
#import "KMPreferences.h"
#endif

AClipboardHistorySwitcher::AClipboardHistorySwitcher()
	:	HBaseAction()
{
}

AClipboardHistorySwitcher::AClipboardHistorySwitcher( const AClipboardHistorySwitcher& inAction )
	:	HBaseAction( inAction )
{
}

AClipboardHistorySwitcher::~AClipboardHistorySwitcher()
{
}

#if KMF_IS_ENGINE

float
AClipboardHistorySwitcher::DoAction()
{
#if KMF_HAS_CLIPBOARD_HISTORY
	ClipboardHistorySwitcherToggleOpen();
	return 10;
#else
	return 0;
#endif
}

#endif

#pragma mark streaming

void
AClipboardHistorySwitcher::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
}

void
AClipboardHistorySwitcher::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
}
