/*
 *  AClipboardSwitcher.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Dec 16 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class CSClipboardDomain;
class XClipboardDataSet;

enum class ClipboardSwitcherType {
	kCut,
	kCopy,
	kPaste
};


class AClipboardSwitcher
	:	public HBaseAction
{

public:
	
private:
	
	ClipboardSwitcherType			mType;

public:
	
	AClipboardSwitcher( ClipboardSwitcherType inType = ClipboardSwitcherType::kPaste );
	AClipboardSwitcher( const AClipboardSwitcher& inAction );
	virtual ~AClipboardSwitcher();

	virtual AClipboardSwitcher*		Clone() const { return new AClipboardSwitcher( *this ); }
	virtual AClipboardSwitcher*		Create() const { return new AClipboardSwitcher(); }
	
	ClipboardSwitcherType			GetType()					{ return mType; }

	virtual HActionType				GetActionType() const;
    virtual CFStringRef				CopyActionTitle() const;

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
	
};

