/*
 *  AComment.h
 *  Keyboard Maestro
 *
 *  Created by Peter N Lewis on Tue 1 Jul 2008.
 *  Copyright (c) 2008 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class AComment
	:	public HBaseAction
{

private:

    CFContainer<CFStringRef>		mTitle;
    CFContainer<CFStringRef>		mText;

public:

    AComment();
	AComment( const AComment& inAction );
    virtual ~AComment();

	virtual AComment*				Clone() const { return new AComment( *this ); }
	virtual AComment*				Create() const { return new AComment(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;

    virtual HActionType				GetActionType() const { return HActionType::kComment; }

	void							SetTitle( CFStringRef inString ) { mTitle = inString->Copy(); }
	CFStringRef						CopyTitle() const { return mTitle->Copy(); }

	void							SetText( CFStringRef inString ) { mText = inString->Copy(); }
	CFStringRef						CopyText() const { return mText->Copy(); }

#if KMF_IS_ENGINE
    virtual float					DoAction() { return 0; }
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;

	virtual	NSString*				GetActionExtraHTML() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

