//
//  ACopyClipboard.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 10 May 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "ClipboardTarget.h"

class ACopyClipboard
	:	public HBaseAction
{
private:

	ClipboardTarget					mSource;
	ClipboardTarget					mTarget;

protected:

public:

    ACopyClipboard();
	ACopyClipboard( const ACopyClipboard& inAction ) = default;
    virtual ~ACopyClipboard() = default;

	virtual ACopyClipboard*			Clone() const { return new ACopyClipboard( *this ); }
	virtual ACopyClipboard*			Create() const { return new ACopyClipboard(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kCopyClipboard; }

	virtual CFStringRef				CopyActionDescriptionString() const;

#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues() { mTarget.UpdateToDefaultValues(); mSource.UpdateToDefaultValues(); }
#endif

	NSString*						GetGenericSourceNamedClipboardUID() const { return mSource.GetGenericNamedClipboardUID(); }
	void							SetGenericSourceNamedClipboardUID( NSString* inUID ) { mSource.SetGenericNamedClipboardUID( inUID ); }

	NSString*						GetGenericTargetNamedClipboardUID() const { return mTarget.GetGenericNamedClipboardUID(); }
	void							SetGenericTargetNamedClipboardUID( NSString* inUID ) { mTarget.SetGenericNamedClipboardUID( inUID ); }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

