//
//  ADeletePastClipboard.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 1 Apr 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class ADeletePastClipboard
	:	public HBaseAction
{

private:

    CFContainer<CFStringRef>		mPastClipboard;

public:

    ADeletePastClipboard();
	ADeletePastClipboard( const ADeletePastClipboard& inAction );
    virtual ~ADeletePastClipboard();

	virtual ADeletePastClipboard*		Clone() const { return new ADeletePastClipboard( *this ); }
	virtual ADeletePastClipboard*		Create() const { return new ADeletePastClipboard(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kDeletePastClipboard; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

	void							SetPastClipboard( CFStringRef inString ) { mPastClipboard = inString->Copy(); }
	CFStringRef						CopyPastClipboard() const { return mPastClipboard->Copy(); }
	NSString*						GetPastClipboard() const { return mPastClipboard->GetNS(); }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

