//
//  ADisplayImage.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 3 May 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "ClipboardTarget.h"

class ADisplayImage
	:	public HBaseAction
{
private:

	ClipboardTarget					mTarget;

protected:

public:

    ADisplayImage() = default;
	ADisplayImage( const ADisplayImage& inAction ) = default;
    virtual ~ADisplayImage() = default;

	virtual ADisplayImage*			Clone() const { return new ADisplayImage( *this ); }
	virtual ADisplayImage*			Create() const { return new ADisplayImage(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kDisplayImage; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues() { mTarget.UpdateToDefaultValues(); }
#endif
	
	NSString*						GetGenericNamedClipboardUID() const { return mTarget.GetGenericNamedClipboardUID(); }
	void							SetGenericNamedClipboardUID( NSString* inUID ) { mTarget.SetGenericNamedClipboardUID( inUID ); }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

