//
//  ADisplayImage.cpp
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 3 May 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "ADisplayImage.h"

#if KMF_EDITOR_WINDOW
#import "ADisplayImageEditor.h"
#endif

#if KMF_IS_ENGINE
#import "XErrorHandler.h"
#import "DisplayImageController.h"
#import "NSImageExtensions.h"
#endif

CFStringRef
ADisplayImage::CopyActionDescriptionString() const
{
	CFContainer<CFStringRef> format = CFSTR("kmDisplayImageFormat")->CopyLocalized();
	return CFString::CreateWithFormat( format, mTarget.GetDisplayName() );
}

#if KMF_IS_ENGINE

float
ADisplayImage::DoAction()
{	
	const XClipboardDataSet* clip = mTarget.GetClipboardDataSet();
	if ( clip ) {
		[DisplayImageController DisplayImageWithContents:clip];
	}
	
	return 5;
}


#endif

#if KMF_EDITOR_WINDOW

Class
ADisplayImage::ActionController() const
{
	return [ADisplayImageEditor class];
}

#endif

#pragma mark streaming

void
ADisplayImage::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
	mTarget.SaveToDictionary( dictionary, CFSTR("Target") );
}

void
ADisplayImage::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
	mTarget.InitializeFromDictionary( dictionary, CFSTR("Target") );
}
