/*
 *  AExecuteAppleScript.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Unknown
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "AExecuteBaseScript.h"

class AExecuteAppleScript
	:	public AExecuteBaseScript
{
private:

#if KMF_IS_ENGINE
	virtual NSString*				GetShellCommand( NSString* path );
	virtual Boolean					StripTrailingLineFeed() { return true; }
#endif
	
	virtual NSString*				GetScriptTypeName() const;

public:

	AExecuteAppleScript();
	AExecuteAppleScript( const AExecuteAppleScript& inAction );
	virtual ~AExecuteAppleScript();

	virtual AExecuteAppleScript*	Clone() const { return new AExecuteAppleScript( *this ); }
	virtual AExecuteAppleScript*	Create() const { return new AExecuteAppleScript(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kExecuteAppleScript; }

#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
};

