/*
 *  AExecuteAppleScript.cpp
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Unknown
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "AExecuteAppleScript.h"
#import "KMPreferences.h"
#import "NSStringExtensions.h"

#if KMF_IS_ENGINE
#import "TempScriptHolder.h"
#endif

#if KMF_EDITOR_WINDOW
#import "AExecuteScriptEditor.h"
#endif

static const MTextResultsWindowKind kDefaultDisplayKind = MTextResultsWindowKind::kNone;

NSString*
AExecuteAppleScript::GetScriptTypeName() const
{
	static NSString* kScriptTypeName = [@"kmExecuteAppleScriptType" localized];
	return kScriptTypeName;
}

AExecuteAppleScript::AExecuteAppleScript()
	:	AExecuteBaseScript( kDefaultDisplayKind )
{
}

AExecuteAppleScript::AExecuteAppleScript( const AExecuteAppleScript& inAction )
	:	AExecuteBaseScript( inAction )
{
}

AExecuteAppleScript::~AExecuteAppleScript()
{
}

#if KMF_IS_ENGINE

NSString*
AExecuteAppleScript::GetShellCommand( NSString* path )
{
	CFContainer<CFStringRef> osascript;
	KMPreferences::Copy( KMPreferences::kOSAScriptCommandID, osascript, CFSTR("/usr/bin/osascript") );
	return [NSString stringWithFormat:@"%@ %@", osascript->GetNS(), [path shellQuotedPath]];
}

#endif

#if KMF_EDITOR_WINDOW

Class
AExecuteAppleScript::ActionController() const
{
	return [AExecuteScriptEditor class];
}

#endif
