//
//  AExecuteJavaScript.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Mon 5 Nov 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "AExecuteBaseScript.h"
#import "WebBrowserInterface.h"

class AExecuteJavaScript
	:	public AExecuteBaseScript
{
private:

#if KMF_IS_ENGINE
	virtual NSString*				GetShellCommand( NSString* path );
	virtual Boolean					StripTrailingLineFeed() { return true; }
#endif

	WebBrowserInterface*			mWebBrowserInterface = WebBrowserInterface::Safari();

	virtual NSString*				GetScriptTypeName() const;

protected:

#if KMF_IS_ENGINE
	virtual TempScriptHolder*		CreateTempScriptHolderForText( NSString* text );
	virtual TempScriptHolder*		CreateTempScriptHolderForPath( NSString* path );
#endif

public:

	AExecuteJavaScript();
 	AExecuteJavaScript( WebBrowserInterface* interface );
	AExecuteJavaScript( const AExecuteJavaScript& inAction ) = default;
	virtual ~AExecuteJavaScript() = default;

	virtual AExecuteJavaScript*	Clone() const { return new AExecuteJavaScript( *this ); }
	virtual AExecuteJavaScript*	Create() const { return new AExecuteJavaScript(); }
	virtual NSString*				GetNewActionTitle() const;
 	virtual	XIcon					GetActionDescriptionXIcon() const { return mWebBrowserInterface->GetXIcon(); }

	virtual WebBrowserInterface*	GetWebBrowserInterface() const { return mWebBrowserInterface; }

	virtual HActionType				GetActionType() const { return HActionType::kExecuteJavaScript; }

#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
};

