//
//  AExecuteMacro.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 19 Mar 2010.
//  Copyright (c) 2010 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class AExecuteMacro
	:	public HBaseAction
{

private:

#if KMF_IS_ENGINE
	NSUUID*							mTrackingID;
#endif

	NSString*						mMacroUID = @"";
	UInt32							mCount = 1; // obsolete

public:

    AExecuteMacro() = default;
	AExecuteMacro( const AExecuteMacro& inAction ) = default;
    virtual ~AExecuteMacro();

	virtual AExecuteMacro*			Clone() const { return new AExecuteMacro( *this ); }
	virtual AExecuteMacro*			Create() const { return new AExecuteMacro(); }
	
 	virtual	CFStringRef				CopyActionDescriptionString() const;
 	virtual	XIcon					GetActionDescriptionXIcon() const;

	virtual HActionType				GetActionType() const { return HActionType::kExecuteMacro; }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return kVeryLongDefaultTimeOutValue; }
	
	virtual Boolean					IsLoop() const { return true; } // technically not a loop, but we stop looking anyway

#if KMF_IS_ENGINE
    virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
	virtual void					ActionAborted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	NSString*						GetMacroUID() const { return mMacroUID; }
	void							SetMacroUID( NSString* inMacroUID ) { mMacroUID = [inMacroUID copy]; }

//	UInt32							GetCount() const { return mCount; }
//	void							SetCount( UInt32 inCount ) { mCount = inCount; };

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

	virtual HBaseAction*			CleanActionAfterInitialization();
};

