/*
 *  AExecuteShellScript.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Feb 10 2002.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "AExecuteBaseScript.h"

class AExecuteShellScript
	:	public AExecuteBaseScript
{
private:

#if KMF_IS_ENGINE
	virtual NSString*				GetShellCommand( NSString* path );
	virtual Boolean					StripTrailingLineFeed() { return false; }
#endif
	
	virtual NSString*				GetScriptTypeName() const;

public:

	AExecuteShellScript();
	AExecuteShellScript( const AExecuteShellScript& inAction );
	virtual ~AExecuteShellScript();

	virtual AExecuteShellScript*	Clone() const { return new AExecuteShellScript( *this ); }
	virtual AExecuteShellScript*	Create() const { return new AExecuteShellScript(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kExecuteShellScript; }

#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
};

