/*
 *  AExecuteShellScript.cpp
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Feb 10 2002.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "AExecuteShellScript.h"
#import "NSStringExtensions.h"

#if KMF_IS_ENGINE
#import "TempScriptHolder.h"
#endif

#if KMF_EDITOR_WINDOW
#import "AExecuteScriptEditor.h"
#endif

static const MTextResultsWindowKind kDefaultDisplayKind = MTextResultsWindowKind::kWindow;

NSString*
AExecuteShellScript::GetScriptTypeName() const
{
	static NSString* kScriptTypeName = [@"kmExecuteShellScriptType" localized];
	return kScriptTypeName;
}

AExecuteShellScript::AExecuteShellScript()
	:	AExecuteBaseScript( kDefaultDisplayKind )
{
}

AExecuteShellScript::AExecuteShellScript( const AExecuteShellScript& inAction )
	:	AExecuteBaseScript( inAction )
{
}

AExecuteShellScript::~AExecuteShellScript()
{
}

#if KMF_IS_ENGINE

NSString*
AExecuteShellScript::GetShellCommand( NSString* path )
{
	return [path shellQuotedPath];
}

#endif

#if KMF_EDITOR_WINDOW

Class
AExecuteShellScript::ActionController() const
{
	return [AExecuteScriptEditor class];
}

#endif
