/*
 *  AExecuteWorkflow.h
 *  Keyboard Maestro
 *
 *  Created by Peter N Lewis on Sun 17 Feb 2008.
 *  Copyright (c) 2008 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"
#import "AExecuteRootScript.h"

class AExecuteWorkflow
	:	public AExecuteRootScript
{
private:

	NSString*						mPath = @"";
	
	virtual NSString*				GetScriptTypeName() const { return @"Automator Workflow"; }

#if KMF_IS_ENGINE

	virtual NSString*				GetLongScriptDisplayName() const { return @"Automator Workflow"; }
	virtual NSString*				GetShellCommand();

	virtual Boolean					StripTrailingLineFeed() { return false; }
	virtual Boolean					TrimResults() { return false; }

	virtual MTextResultsWindowKind	DisplayKind() { return MTextResultsWindowKind::kNone; }

#endif

protected:

public:

    AExecuteWorkflow() = default;
	AExecuteWorkflow( const AExecuteWorkflow& inAction ) = default;
    virtual ~AExecuteWorkflow() = default;

	virtual AExecuteWorkflow*		Clone() const { return new AExecuteWorkflow( *this ); }
	virtual AExecuteWorkflow*		Create() const { return new AExecuteWorkflow(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kExecuteWorkflow; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

	NSString*						GetPath() const { return mPath; }
	void							SetPath( NSString* path ) { mPath = [path copy]; }
	
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

