/*
 *  AFastUserSwitch.h
 *  Keyboard Maestro
 *
 *  Created by Peter N Lewis on Thu 10 Jul 2008.
 *  Copyright (c) 2008 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class AFastUserSwitch
	:	public HBaseAction
{
private:

    CFContainer<CFStringRef>	mUserName;
	
public:
	
    AFastUserSwitch();
	AFastUserSwitch( const AFastUserSwitch& inAction );
    virtual ~AFastUserSwitch();

	virtual AFastUserSwitch*		Clone() const { return new AFastUserSwitch( *this ); }
	virtual AFastUserSwitch*		Create() const { return new AFastUserSwitch(); }
	
	void							SetUserName( CFStringRef inuserName ) { mUserName = inuserName->Copy(); }
	CFStringRef						CopyUserName() const { return mUserName->Copy(); }
	NSString*						GetUserName() const { return mUserName->GetNS(); }

    virtual HActionType				GetActionType() const { return HActionType::kFastUserSwitch; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

