//
//  AFilterVariable.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Tue 10 May 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "FilterText.h"
#import "KMVariables.h"
#import "VariableTransformationAction.h"

class AFilterVariable
	:	public HBaseAction,
		public VariableTransformationAction
{

private:

	VariableContainer				mVariable;
	FilterText::Action			mAction;

public:

    AFilterVariable();
	AFilterVariable( const AFilterVariable& inAction );
    virtual ~AFilterVariable();

	virtual AFilterVariable*		Clone() const { return new AFilterVariable( *this ); }
	virtual AFilterVariable*		Create() const { return new AFilterVariable(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kFilterVariable; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

	virtual CFStringRef				CopyTransformationResult( NSUInteger* errorPos = NULL, float* time = NULL ) const;
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	virtual void					SetVariable( NSString* inVariable ) { check( inVariable ); mVariable = [inVariable copy]; }
	virtual NSString*				GetVariable() const { return mVariable->GetNS(); }

	void							SetAction( FilterText::Action inValue ) { mAction = inValue; }
	FilterText::Action				GetAction() const { return mAction; }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
	
};

