//
//  AGetImageSize.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Wed 2 May 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "KMVariables.h"
#import "ClipboardTarget.h"

class AGetImageSize
	:	public HBaseAction
{

private:

	ClipboardTarget					mTarget;
	VariableContainer				mVariable;
	
public:

    AGetImageSize();
	AGetImageSize( const AGetImageSize& inAction );
    virtual ~AGetImageSize();

	virtual AGetImageSize*			Clone() const { return new AGetImageSize( *this ); }
	virtual AGetImageSize*			Create() const { return new AGetImageSize(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kGetImageSize; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues() { mTarget.UpdateToDefaultValues(); }
#endif

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif

	NSString*						GetGenericNamedClipboardUID() const { return mTarget.GetGenericNamedClipboardUID(); }
	void							SetGenericNamedClipboardUID( NSString* inUID ) { mTarget.SetGenericNamedClipboardUID( inUID ); }
		
	virtual void					SetVariable( NSString* inVariable ) { check( inVariable ); mVariable = [inVariable copy]; }
	virtual NSString*				GetVariable() const { return mVariable->GetNS(); }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
	
};

