//
//  AGrowl.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Wed 7 Oct 2009.
//  Copyright (c) 2009 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class AGrowl
	:	public HBaseAction
{

private:

    CFContainer<CFStringRef>		mTitle;
    CFContainer<CFStringRef>		mText;

public:

    AGrowl();
	AGrowl( const AGrowl& inAction );
    virtual ~AGrowl();

	virtual AGrowl*					Clone() const { return new AGrowl( *this ); }
	virtual AGrowl*					Create() const { return new AGrowl(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;

    virtual HActionType				GetActionType() const { return HActionType::kGrowl; }

	void							SetTitle( CFStringRef inString ) { mTitle = inString->Copy(); }
	CFStringRef						CopyTitle() const { return mTitle->Copy(); }

	void							SetText( CFStringRef inString ) { mText = inString->Copy(); }
	CFStringRef						CopyText() const { return mText->Copy(); }

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;

	virtual	NSString*				GetActionExtraHTML() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

