/*
 *  AHideApplications.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Dec 16 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

enum class EHideApplicationsActionType {
	kAllApplications,
	kOtherApplications,
	kCurrentApplication,
	kDEFAULT = kOtherApplications,
};

class AHideApplications
	:	public HBaseAction
{
public:

private:

    EHideApplicationsActionType		mHideActionType;
    Boolean							mHonorExcluded;

public:

	AHideApplications( const EHideApplicationsActionType& inType = EHideApplicationsActionType::kDEFAULT );
	AHideApplications( const AHideApplications& inAction ) = default;
	virtual ~AHideApplications() = default;
	
	virtual AHideApplications*		Clone() const { return new AHideApplications( *this ); }
	virtual AHideApplications*		Create() const { return new AHideApplications(); }
	
	void							SetHonorExcluded( const Boolean& inValue ) { mHonorExcluded = inValue; }
	Boolean							GetHonorExcluded() const { return mHonorExcluded; }
	
    void							SetHideActionType( const EHideApplicationsActionType& inValue ) { mHideActionType = inValue; }
    EHideApplicationsActionType		GetHideActionType() const { return mHideActionType; }
	
    virtual HActionType				GetActionType() const;

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
};

