//
//  AHideSpecificApplication.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Mon 21 Sep 2009.
//  Copyright (c) 2009 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "XApplicationIdentifier.h"

class AHideSpecificApplication
	:	public HBaseAction
{
private:

	XApplicationIdentifier		mApplication;
	
public:
	
    AHideSpecificApplication() = default;
	AHideSpecificApplication( const AHideSpecificApplication& inAction ) = default;
    virtual ~AHideSpecificApplication() = default;
	
	virtual AHideSpecificApplication*		Clone() const { return new AHideSpecificApplication( *this ); }
	virtual AHideSpecificApplication*		Create() const { return new AHideSpecificApplication(); }
	
#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues();
#endif
	
	virtual	CFStringRef				CopyActionDescriptionString() const;
 	virtual	XIcon					GetActionDescriptionXIcon() const;
	
	virtual HActionType				GetActionType() const { return HActionType::kHideSpecificApp; }

    virtual const XApplicationIdentifier&	GetApplication() const { return mApplication; }
	virtual void							SetApplication( const XApplicationIdentifier& inApp ) { mApplication = inApp; }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

};

