//
//  AHideSpecificApplication.cpp
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Mon 21 Sep 2009.
//  Copyright (c) 2009 Stairways Software. All rights reserved.
//

#import "AHideSpecificApplication.h"
#import "KMIconRegistry.h"
#if KMF_IS_ENGINE
#import "XRunningApplicationsList.h"
#endif
#if KMF_EDITOR_WINDOW
#import "AHideSpecificApplicationEditor.h"
#endif

#if KMF_EDITOR_WINDOW
void
AHideSpecificApplication::UpdateToDefaultValues()
{
	if ( !mApplication.HasValue() ) {
		mApplication = XApplicationIdentifier::FinderDefaultApplication();
	}
}
#endif

CFStringRef
AHideSpecificApplication::CopyActionDescriptionString() const
{
	NSString* theNameStr = mApplication.GetName();
	CFContainer<CFStringRef> theFormatStr = CFSTR("kmHideSpecificAppTitleFormat")->CopyLocalized();
	return CFString::CreateWithFormat( theFormatStr, theNameStr );
}

XIcon
AHideSpecificApplication::GetActionDescriptionXIcon() const
{
	return GetApplication().GetXIcon().DimmedIcon();
}

#if KMF_IS_ENGINE

float
AHideSpecificApplication::DoAction()
{
	mApplication.Hide();	
	return 20;
}

#endif

#if KMF_EDITOR_WINDOW

Class
AHideSpecificApplication::ActionController() const
{
	return [AHideSpecificApplicationEditor class];
}

#endif

#pragma mark streaming

void
AHideSpecificApplication::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
	SafeCFPropertyListRef app = mApplication.CopyToPropertyList();
	dictionary->Set( CFSTR("Application"), app );
	CFRelease( app );
}

void
AHideSpecificApplication::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
	SafeCFPropertyListRef app = (SafeCFPropertyListRef)dictionary->Get( CFSTR("Application") );
	XAssert( app );
	mApplication.LoadFromPropertyList( app );
}
