/*
 *  ALastApplication.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sat Dec 15 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class ALastApplication
	:	public HBaseAction
{
private:
#if KMF_IS_ENGINE
	ProcessSerialNumber				mLastAppPSN;
#endif

public:
    ALastApplication();
    ALastApplication( const ALastApplication& inAction );
    virtual ~ALastApplication();

	virtual ALastApplication*		Clone() const { return new ALastApplication( *this ); }
	virtual ALastApplication*		Create() const { return new ALastApplication(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSwitchToLastApplication; }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return 20*kEventDurationSecond; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
	Boolean							IsActionCompleted();
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

