/*
 *  ALastApplication.cpp
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sat Dec 15 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "ALastApplication.h"
#if KMF_IS_ENGINE
#import "XErrorHandler.h"
#import "XRunningApplicationsList.h"
#import "ProcessSerialNumberUtils.h"
#endif

ALastApplication::ALastApplication()
	:	HBaseAction()
{
}
ALastApplication::ALastApplication( const ALastApplication& inAction )
	:	HBaseAction( inAction )
{
}

ALastApplication::~ALastApplication()
{

}

#if KMF_IS_ENGINE
float
ALastApplication::DoAction()
{
	mLastAppPSN = XRunningApplicationsList::GetLastApplication();
	XErrorHandlerMaybeLogPSN( "RunningApplicationsList", @"ALastApplication switch to %@", &mLastAppPSN );
	verify_noerr( SetFrontProcess( &mLastAppPSN ) );
	return 2;
}

Boolean
ALastApplication::IsActionCompleted()
{
	ProcessSerialNumber		frontPSN;
	GetFrontProcess( &frontPSN );
	XErrorHandlerMaybeLogPSN( "RunningApplicationsList", @"ALastApplication current is %@", &frontPSN );
	return PSN::SameProcess( frontPSN, mLastAppPSN );
}

#endif

#pragma mark streaming

void
ALastApplication::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
}

void
ALastApplication::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
}
