//
//  ALog.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 13 Jun 2013.
//  Copyright (c) 2013 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class ALog
	:	public HBaseAction
{

private:

    NSString*						mText = @"Message";

public:

    ALog() = default;
	ALog( const ALog& inAction ) = default;
    virtual ~ALog() = default;

	virtual ALog*					Clone() const { return new ALog( *this ); }
	virtual ALog*					Create() const { return new ALog(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;

    virtual HActionType				GetActionType() const { return HActionType::kLog; }

	void							SetText( NSString* inString ) { mText = [inString copy]; }
	NSString*						GetText() const { return mText; }

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

