//
//  ALog.mm
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 13 Jun 2013.
//  Copyright (c) 2013 Stairways Software. All rights reserved.
//

#import "ALog.h"
#if KMF_IS_ENGINE
#import "TokenText.h"
#import "XErrorHandler.h"
#endif
#if KMF_EDITOR_WINDOW
#import "ALogEditor.h"
#endif

CFStringRef
ALog::CopyActionDescriptionString() const
{
	return CFString::CreateWithFormat( CFCS( CFSTR("hkLogTitle")->CopyLocalized() ), mText );
}

#if KMF_IS_ENGINE

float
ALog::DoAction()
{
	float time;
	
	XErrorHandlerMaybeLogFormat1( "display", @"Log: %@", TokenText::GetResult( mText, &time ) );
	return 1 + time;
}

#endif

#if KMF_EDITOR_WINDOW

Class
ALog::ActionController() const
{
	return [ALogEditor class];
}

#endif

#pragma mark streaming

void
ALog::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
	dictionary->Set( CFSTR("Text"), CFBridgingToCFString(mText) );
}

void
ALog::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
	CFStringRef newText;
	XAssert( dictionary->Get( CFSTR("Text"), newText ) );
	mText = newText->GetNS();
}
