//
//  ANewFolder.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Wed 11 Apr 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class ANewFolder
	:	public HBaseAction
{

private:

	NSString*						mDestination = @"";

public:

    ANewFolder() = default;
	ANewFolder( const ANewFolder& inAction ) = default;
    virtual ~ANewFolder() = default;

	virtual ANewFolder*				Clone() const { return new ANewFolder( *this ); }
	virtual ANewFolder*				Create() const { return new ANewFolder(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kNewFolder; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	NSString*						GetDestination() const { return mDestination; }
	void							SetDestination( NSString* destination ) { mDestination = [destination copy]; }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
	
};

