//
//  ANewImage.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 4 May 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "ClipboardTarget.h"

class ANewImage
	:	public HBaseAction
{
private:

	ClipboardTarget					mTarget;
    CFContainer<CFStringRef>		mWidthNumber;
    CFContainer<CFStringRef>		mHeightNumber;
	NSColor*						mColor;

protected:

public:

    ANewImage();
	ANewImage( const ANewImage& inAction );
	
    virtual ~ANewImage();

	virtual ANewImage*				Clone() const { return new ANewImage( *this ); }
	virtual ANewImage*				Create() const { return new ANewImage(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kNewImage; }
	
#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues() { mTarget.UpdateToDefaultValues(); }
#endif
	
	NSString*						GetGenericNamedClipboardUID() const { return mTarget.GetGenericNamedClipboardUID(); }
	void							SetGenericNamedClipboardUID( NSString* inUID ) { mTarget.SetGenericNamedClipboardUID( inUID ); }
	
	void							SetWidthNumber( CFStringRef inString ) { mWidthNumber = inString->Copy(); }
	void							SetWidthNumber( double inValue ) { mWidthNumber = CFString::CreateWithNumber(lround(inValue)); }
	CFStringRef						CopyWidthNumber() const { return mWidthNumber->Copy(); }
	NSString*						GetWidthNumber() const { return mWidthNumber->GetNS(); }
	
	void							SetHeightNumber( CFStringRef inString ) { mHeightNumber = inString->Copy(); }
	void							SetHeightNumber( double inValue ) { mHeightNumber = CFString::CreateWithNumber(lround(inValue)); }
	CFStringRef						CopyHeightNumber() const { return mHeightNumber->Copy(); }
	NSString*						GetHeightNumber() const { return mHeightNumber->GetNS(); }
	
	NSColor*						GetColor() const { return mColor; }
	void							SetColor( NSColor* inColor );
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

