/*
 *  ANextApplication.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Dec 16 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class ANextApplication
	:	public HBaseAction
{
private:
#if KMF_IS_ENGINE
	ProcessSerialNumber				mNextAppPSN;
#endif


public:
    ANextApplication();
	ANextApplication( const ANextApplication& inAction );
    virtual ~ANextApplication();

	virtual ANextApplication*		Clone() const { return new ANextApplication( *this ); }
	virtual ANextApplication*		Create() const { return new ANextApplication(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSwitchToNextApplication; }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return 20*kEventDurationSecond; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
	Boolean							IsActionCompleted();
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );


};

