/*
 *  ANextApplication.cpp
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Dec 16 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "ANextApplication.h"
#if KMF_IS_ENGINE
#import "XErrorHandler.h"
#import "XRunningApplicationsList.h"
#import "ProcessSerialNumberUtils.h"
#endif

ANextApplication::ANextApplication()
	:	HBaseAction()
{
}
ANextApplication::ANextApplication( const ANextApplication& inAction )
	:	HBaseAction( inAction )
{
}

ANextApplication::~ANextApplication()
{
}

#if KMF_IS_ENGINE
float
ANextApplication::DoAction()
{
	mNextAppPSN = XRunningApplicationsList::GetNextApplication();
	XErrorHandlerMaybeLogPSN( "RunningApplicationsList", @"ANextApplication switch to %@", &mNextAppPSN );
	verify_noerr( SetFrontProcess( &mNextAppPSN ) );
	return 2;
}

Boolean
ANextApplication::IsActionCompleted()
{
	ProcessSerialNumber		frontPSN;
	GetFrontProcess( &frontPSN );
	XErrorHandlerMaybeLogPSN( "RunningApplicationsList", @"ANextApplication current is %@", &frontPSN );
	return PSN::SameProcess( frontPSN, mNextAppPSN );
}

#endif

#pragma mark streaming

void
ANextApplication::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
}

void
ANextApplication::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
}
