//
//  ANotification.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Tue 27 Nov 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class ANotification
	:	public HBaseAction
{

private:

    NSString*						mTitle;
    NSString*						mSubtitle;
    NSString*						mText;
    NSString*						mSoundName; // can be NSUserNotificationDefaultSoundName or ""

public:

    ANotification();
	ANotification( const ANotification& inAction ) = default;
    virtual ~ANotification() = default;

	virtual ANotification*			Clone() const { return new ANotification( *this ); }
	virtual ANotification*			Create() const { return new ANotification(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;

    virtual HActionType				GetActionType() const { return HActionType::kNotification; }

	void							SetTitle( NSString* inString ) { mTitle = [inString copy]; }
	NSString*						GetTitle() const { return mTitle; }

	void							SetSubtitle( NSString* inString ) { mSubtitle = [inString copy]; }
	NSString*						GetSubtitle() const { return mSubtitle; }

	void							SetText( NSString* inString ) { mText = [inString copy]; }
	NSString*						GetText() const { return mText; }

	void							SetSoundName( NSString* inString ) { mSoundName = [inString copy]; }
	NSString*						GetSoundName() const { return mSoundName; }

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;

	virtual	NSString*				GetActionExtraHTML() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

