//
//  AOpenFinderSelection.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Tue 10 May 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "ApplicationTarget.h"


class AOpenFinderSelection
	:	public HBaseAction
{
private:

	ApplicationTarget				mTargetApplication;

public:
	
    AOpenFinderSelection() = default;
	AOpenFinderSelection( const AOpenFinderSelection& inAction ) = default;
    virtual ~AOpenFinderSelection() = default;
	
	virtual AOpenFinderSelection*	Clone() const { return new AOpenFinderSelection( *this ); }
	virtual AOpenFinderSelection*	Create() const { return new AOpenFinderSelection(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;
 	virtual	XIcon					GetActionDescriptionXIcon() const;
	
	virtual HActionType				GetActionType() const { return HActionType::kOpenFinderSelection; }

	ApplicationTargetApplicationType		GetApplicationTargetType() const { return mTargetApplication.GetApplicationTargetType(); }
    virtual const XApplicationIdentifier&	GetTargetApplication() const { return mTargetApplication.GetTargetApplication(); }

	void							SetApplicationTargetApplication( const XApplicationIdentifier& inApp ) { mTargetApplication.SetApplicationTargetApplication( inApp ); }
	void							SetApplicationTargetFrontApplication() { mTargetApplication.SetApplicationTargetFrontApplication(); }

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
	
};

