/*
 *  AOpenPrefPane.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Mon Mar 18 2002.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"
#import "XAlias.h"

class AOpenPrefPane
	:	public HBaseAction
{
private:
	
    XAlias			mAlias;

public:
	
    AOpenPrefPane();
	AOpenPrefPane( const AOpenPrefPane& inAction );
    virtual ~AOpenPrefPane();

	virtual AOpenPrefPane*			Clone() const { return new AOpenPrefPane( *this ); }
	virtual AOpenPrefPane*			Create() const { return new AOpenPrefPane(); }
	
#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues();
#endif
	
	virtual	CFStringRef				CopyActionDescriptionString() const;
	virtual	XIcon					GetActionDescriptionXIcon() const;
 	
	virtual HActionType				GetActionType() const { return HActionType::kSystemPrefPane; }

    virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

    virtual NSString*				GetFilePath() const { return mAlias.GetPath(); }
	virtual void					SetFilePath( NSString* inPath ) { mAlias = XAlias( inPath ); }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return 20*kEventDurationSecond; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

};

