/*
 *  APause.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun May 12 2002.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class APause
	:	public HBaseAction
{

private:

#if KMF_IS_ENGINE
	EventTime						mActionFinishTime;
#endif

    CFContainer<CFStringRef>		mPauseTime;

public:

    APause();
	APause( const APause& inAction );
    virtual ~APause();

	virtual APause*					Clone() const { return new APause( *this ); }
	virtual APause*					Create() const { return new APause(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;

    virtual HActionType				GetActionType() const { return HActionType::kPause; }

	void							SetPauseTime( CFStringRef inString ) { mPauseTime = inString->Copy(); }
	CFStringRef						CopyPauseTime() const { return mPauseTime->Copy(); }
	NSString*						GetPauseTime() const { return mPauseTime->GetNS(); }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return kVeryLongDefaultTimeOutValue; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

