//
//  APauseUntil.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 4 Feb 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "CConditionList.h"

class APauseUntil
	:	public HBaseAction
{

private:

	CConditionList					mConditions;

#if KMF_IS_ENGINE
	EventTime						mActionNextCheckTime;
#endif

public:

    APauseUntil();
	APauseUntil( const APauseUntil& inAction );
    virtual ~APauseUntil();

	virtual APauseUntil*			Clone() const { return new APauseUntil( *this ); }
	virtual APauseUntil*			Create() const { return new APauseUntil(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;

    virtual HActionType				GetActionType() const { return HActionType::kPauseUntil; }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return kVeryLongDefaultTimeOutValue; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
	virtual void					ActionAborted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	
	virtual	NSString*				GetActionHTMLDescriptionString() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif

	virtual BOOL					MatchesTextSearch( NSString* search ) const;

	const CConditionList&			GetConditionList() const { return mConditions; }
	void							SetConditionList( const CConditionList& inConditions ) { mConditions = inConditions; }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

