/*
 *  AQuitApplications.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Dec 16 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

enum class EQuitApplicationsActionType {
	kAllApplications,
	kOtherApplications
};

class AQuitApplications
	:	public HBaseAction
{
private:

    EQuitApplicationsActionType		mQuitActionType;
    Boolean							mHonorExcluded;

public:

	AQuitApplications( const EQuitApplicationsActionType& inType = EQuitApplicationsActionType::kAllApplications );
	AQuitApplications( const AQuitApplications& inAction ) = default;
	virtual ~AQuitApplications() = default;
	
	virtual AQuitApplications*		Clone() const { return new AQuitApplications( *this ); }
	virtual AQuitApplications*		Create() const { return new AQuitApplications(); }
	
	void							SetHonorExcluded( const Boolean& inValue ) { mHonorExcluded = inValue; }
	Boolean							GetHonorExcluded() const { return mHonorExcluded; }
	
    void							SetQuitActionType( const EQuitApplicationsActionType& inValue ) { mQuitActionType = inValue; }
    EQuitApplicationsActionType		GetQuitActionType() const { return mQuitActionType; }
	
    virtual HActionType				GetActionType() const;

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
};

