//
//  ASearch.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 24 Sep 2009.
//  Copyright (c) 2009 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

@class SearchWindowController;

class ASearch : public HBaseAction
{
private:

	NSColor*						mColor;
	NSString*						mTitle;
	NSString*						mURL;
	NSString*						mDefault;

#if KMF_IS_ENGINE
	SearchWindowController*			mSearchWindowController;
#endif

public:
	ASearch();
	ASearch( const ASearch& inAction );
	virtual ~ASearch();

	virtual ASearch*				Clone() const { return new ASearch( *this ); }
	virtual ASearch*				Create() const { return new ASearch(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kSearch; }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return 3*kEventDurationMinute; }
	
#if KMF_IS_ENGINE
	virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
	virtual void					ActionAborted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif
	
	NSColor*						GetColor() const { return mColor; }
	void							SetColor( NSColor* inColor );
	
	void							SetTitle( NSString* inString ) { mTitle = [inString copy]; }
	NSString*						GetTitle() const { return mTitle; }
	
	void							SetURL( NSString* inString ) { mURL = [inString copy]; }
	NSString*						GetURL() const { return mURL; }

	void							SetDefault( NSString* inString ) { mDefault = [inString copy]; }
	NSString*						GetDefault() const { return mDefault; }

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

