//
//  ASendMessageToEditor.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 27 Apr 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class ASendMessageToEditor
	:	public HBaseAction
{

private:

	CFContainer<CFStringRef>		mMessageUID;
	CFContainer<CFStringRef>		mMessageResult;

public:

    ASendMessageToEditor();
	ASendMessageToEditor( const ASendMessageToEditor& inAction );
    virtual ~ASendMessageToEditor();

	virtual ASendMessageToEditor*		Clone() const { return new ASendMessageToEditor( *this ); }
	virtual ASendMessageToEditor*		Create() const { return new ASendMessageToEditor(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSendMessageToEditor; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

	CFStringRef						CopyMessageUID() const { return mMessageUID->Copy(); }
	NSString*						GetMessageUID() const { return mMessageUID->GetNS(); }
	void							SetMessageUID( CFStringRef inMessageUID ) { mMessageUID = inMessageUID->Copy(); }
	
	CFStringRef						CopyMessageResult() const { return mMessageResult->Copy(); }
	NSString*						GetMessageResult() const { return mMessageResult->GetNS(); }
	void							SetMessageResult( CFStringRef inMessageResult ) { mMessageResult = inMessageResult->Copy(); }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

