//
//  ASendMessageToEditor.cpp
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 27 Apr 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "ASendMessageToEditor.h"
#import "XNotificationCenter.h"
#import "KMNotifications.h"

ASendMessageToEditor::ASendMessageToEditor()
	:	HBaseAction(),
		mMessageUID( CFSTR("")->Copy() ),
		mMessageResult( CFSTR("")->Copy() )
{
}

ASendMessageToEditor::ASendMessageToEditor( const ASendMessageToEditor& inAction )
	:	HBaseAction( inAction ),
		mMessageUID( inAction.mMessageUID ),
		mMessageResult( inAction.mMessageResult )
{
}
	
ASendMessageToEditor::~ASendMessageToEditor()
{
}
	
CFStringRef
ASendMessageToEditor::CopyActionDescriptionString() const
{
	return CFSTR("Send Message To Editor"); // never visible to users
}

#if KMF_IS_ENGINE

float
ASendMessageToEditor::DoAction()
{
	XNotificationCenter::PostNotification( KMNotifications::kMessageResponse, @{
										  KMNotifications::kMessageUID : mMessageUID->GetNS(),
										  KMNotifications::kMessageResult : mMessageResult->GetNS()
										  } );
	return 0;
}

#endif

#pragma mark streaming

void
ASendMessageToEditor::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
	dictionary->Set( CFSTR( "MessageUID" ), CFStringRef(mMessageUID) );
	dictionary->Set( CFSTR( "MessageResult" ), CFStringRef(mMessageResult) );
}

void
ASendMessageToEditor::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
	CFStringRef value;
	dictionary->Get( CFSTR("MessageUID"), value, CFSTR("") );
	check( value );
	mMessageUID = value->Copy();
	dictionary->Get( CFSTR("MessageResult"), value, CFSTR("") );
	check( value );
	mMessageResult = value->Copy();
}
