//
//  ASetFindPasteboard.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 15 Apr 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class ASetFindPasteboard
	:	public HBaseAction
{
private:

    NSString*						mText = @"";
	
public:
	
    ASetFindPasteboard() = default;
	ASetFindPasteboard( const ASetFindPasteboard& inAction ) = default;
    virtual ~ASetFindPasteboard() = default;

	virtual ASetFindPasteboard*	Clone() const { return new ASetFindPasteboard( *this ); }
	virtual ASetFindPasteboard*	Create() const { return new ASetFindPasteboard(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSetFindPasteboard; }
	virtual	CFStringRef				CopyActionDescriptionString() const;
	
	void							SetText( NSString* inString ) { check(inString); mText = [inString copy]; }
	NSString*						GetText() const { return mText; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

