//
//  ASetKeychainPasswordToText.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Wed 6 Feb 2013.
//  Copyright (c) 2013 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "KMVariables.h"
#import "AExecuteRootScript.h"

class ASetKeychainPasswordToText
	:	public AExecuteRootScript
{
private:

    NSString*						mPasswordName = @"Password Name";
    NSString*						mPasswordAccount = @"%UserLoginID%";
    NSString*						mText = @"";

	virtual NSString*				GetScriptTypeName() const { return @"Set Keychain Password To Text"; }

#if KMF_IS_ENGINE

	virtual NSString*				GetLongScriptDisplayName() const { return @"Set Keychain Password To Text"; }
	virtual NSString*				GetShellCommand();

	virtual Boolean					StripTrailingLineFeed() { return false; }
	virtual Boolean					TrimResults() { return false; }

	virtual MTextResultsWindowKind	DisplayKind() { return MTextResultsWindowKind::kNone; }

#endif

public:
	
    ASetKeychainPasswordToText() = default;
	ASetKeychainPasswordToText( const ASetKeychainPasswordToText& inAction ) = default;
    virtual ~ASetKeychainPasswordToText() = default;

	virtual ASetKeychainPasswordToText*	Clone() const { return new ASetKeychainPasswordToText( *this ); }
	virtual ASetKeychainPasswordToText*	Create() const { return new ASetKeychainPasswordToText(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSetKeychainPasswordToText; }
	virtual	CFStringRef				CopyActionDescriptionString() const;
	
	void							SetPasswordName( NSString* inString ) { check(inString); mPasswordName = [inString copy]; }
	NSString*						GetPasswordName() const { return mPasswordName; }

	void							SetPasswordAccount( NSString* inString ) { check(inString); mPasswordAccount = [inString copy]; }
	NSString*						GetPasswordAccount() const { return mPasswordAccount; }

	void							SetText( NSString* inString ) { check(inString); mText = [inString copy]; }
	NSString*						GetText() const { return mText; }

#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

