//
//  ASetMacroEnable.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Tue 1 Mar 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

typedef enum { // WARNING: tag valued in AManipulateWindow.xib match this enum
	kSetMacroEnableEnable,
	kSetMacroEnableDisable,
	kSetMacroEnableToggle,
	kSetMacroEnableDEFAULT = kSetMacroEnableEnable, 
} SetMacroEnableType;
#define kSetMacroEnableTypeNamesArray {CFSTR("Enable"), CFSTR("Disable"), CFSTR("Toggle"), NULL}

class ASetMacroEnable
	:	public HBaseAction
{

private:

	SetMacroEnableType				mAction;
	CFContainer<CFStringRef>		mMacroUID;

public:

    ASetMacroEnable();
	ASetMacroEnable( const ASetMacroEnable& inAction );
    virtual ~ASetMacroEnable();

	virtual ASetMacroEnable*		Clone() const { return new ASetMacroEnable( *this ); }
	virtual ASetMacroEnable*		Create() const { return new ASetMacroEnable(); }
	
 	virtual	CFStringRef				CopyActionDescriptionString() const;
	
    virtual HActionType				GetActionType() const { return HActionType::kSetMacroEnable; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif

	CFStringRef						CopyMacroUID() const { return mMacroUID->Copy(); }
	void							SetMacroUID( CFStringRef inMacroUID ) { mMacroUID = inMacroUID->Copy(); }

	SetMacroEnableType				GetAction() const { return mAction; }
	void							SetAction( SetMacroEnableType inAction ) { mAction = inAction; }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

