//
//  ASetNetworkLocation.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Mon 18 Mar 2013.
//  Copyright (c) 2013 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "NSStringExtensions.h"

class ASetNetworkLocation
	:	public HBaseAction
{
private:

	NSString*						mNetworkLocation = @"";

protected:


public:
    ASetNetworkLocation() = default;
 	ASetNetworkLocation( const ASetNetworkLocation& inAction ) = default;
	virtual ~ASetNetworkLocation() = default;

	virtual ASetNetworkLocation*	Clone() const { return new ASetNetworkLocation( *this ); }
	virtual ASetNetworkLocation*	Create() const { return new ASetNetworkLocation(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSetNetworkLocation; }
	virtual	CFStringRef				CopyActionDescriptionString() const;

	void							SetNetworkLocation( NSString* inString ) { mNetworkLocation = [inString copy]; }
	NSString*						GetNetworkLocation() const { return mNetworkLocation; }

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual void					UpdateToDefaultValues();
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

