//
//  ASetNetworkLocation.cpp
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Mon 18 Mar 2013.
//  Copyright (c) 2013 Stairways Software. All rights reserved.
//

#import "ASetNetworkLocation.h"
#import "KMIconRegistry.h"
#import "NSObjectExtensions.h"
#import "NetworkLocation.h"
#if KMF_IS_ENGINE
#import "TokenText.h"
#endif
#if KMF_EDITOR_WINDOW
#import "ASetNetworkLocationEditor.h"
#endif

CFStringRef ASetNetworkLocation::CopyActionDescriptionString() const
{
	CFContainer<CFStringRef> format = CFSTR("kmSetNetworkLocationFormat")->CopyLocalized();
	return CFString::CreateWithFormat( format, mNetworkLocation);
}

#if KMF_IS_ENGINE

float
ASetNetworkLocation::DoAction()
{
	float time = 0;
	NSString* token = TokenText::GetResult( mNetworkLocation, &time );
	NetworkLocation::Set( token );
	return time;
}

#endif

#if KMF_EDITOR_WINDOW

void
ASetNetworkLocation::UpdateToDefaultValues()
{
	if ( IsEmpty( mNetworkLocation ) ) {
		mNetworkLocation = NetworkLocation::Get();
	}
}

Class
ASetNetworkLocation::ActionController() const
{
	return [ASetNetworkLocationEditor class];
}

#endif

#pragma mark streaming

void
ASetNetworkLocation::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
	dictionary->Set( CFSTR("NetworkLocation"), CFBridgingToCFString(mNetworkLocation) );
}

void
ASetNetworkLocation::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
	CFStringRef newNetworkLocation;
	dictionary->Get( CFSTR("NetworkLocation"), newNetworkLocation, CFSTR("") );
	mNetworkLocation = CFBridgingToNS(newNetworkLocation);
}
