//
//  ASetVariableToCalculation.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Wed 20 Apr 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "VariableTransformationAction.h"
#import "KMVariables.h"

class ASetVariableToCalculation
	:	public HBaseAction,
		public VariableTransformationAction
{
private:

	VariableContainer				mVariable = @"Variable";
    NSString*						mText = @"1";
    Boolean							mUseFormat = false;
    NSString*						mFormat = @"0.00";

public:
	
    ASetVariableToCalculation() = default;
	ASetVariableToCalculation( const ASetVariableToCalculation& inAction ) = default;
    virtual ~ASetVariableToCalculation() = default;

	virtual ASetVariableToCalculation*	Clone() const { return new ASetVariableToCalculation( *this ); }
	virtual ASetVariableToCalculation*	Create() const { return new ASetVariableToCalculation(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSetVariableToCalculation; }
	virtual	CFStringRef				CopyActionDescriptionString() const;
	
	virtual void					SetVariable( NSString* inVariable ) { check( inVariable ); mVariable = [inVariable copy]; }
	virtual NSString*				GetVariable() const { return mVariable->GetNS(); }

	void							SetText( NSString* inString ) { mText = [inString copy]; }
	NSString*						GetText() const { return mText; }

	void							SetNoFormat() { mUseFormat = false; }
	void							SetFormat( NSString* inString ) { mFormat = [inString copy]; mUseFormat = true; }
	NSString*						GetFormat() const { return mFormat; }
	Boolean							GetUseFormat() const { return mUseFormat; }

	virtual CFStringRef				CopyTransformationResult( NSUInteger* errorPos = NULL, float* time = NULL ) const;
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

