//
//  ASetVariableToText.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Fri 15 Apr 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "VariableTransformationAction.h"
#import "KMVariables.h"

class ASetVariableToText
	:	public HBaseAction,
		public VariableTransformationAction
{
private:

	VariableContainer				mVariable = @"Variable";
    NSString*						mText = @"";
	
public:
	
    ASetVariableToText() = default;
	ASetVariableToText( const ASetVariableToText& inAction ) = default;
    virtual ~ASetVariableToText() = default;

	virtual ASetVariableToText*	Clone() const { return new ASetVariableToText( *this ); }
	virtual ASetVariableToText*	Create() const { return new ASetVariableToText(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kSetVariableToText; }
	virtual	CFStringRef				CopyActionDescriptionString() const;
	
	virtual void					SetVariable( NSString* inVariable ) { check( inVariable ); mVariable = [inVariable copy]; }
	virtual NSString*				GetVariable() const { return mVariable->GetNS(); }

	void							SetText( NSString* inString ) { check(inString); mText = [inString copy]; }
	NSString*						GetText() const { return mText; }
	
	virtual CFStringRef				CopyTransformationResult( NSUInteger* errorPos = NULL, float* time = NULL ) const;

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

