//
//  AShowSpecificApplication.cpp
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Mon 21 Sep 2009.
//  Copyright (c) 2009 Stairways Software. All rights reserved.
//

#import "AShowSpecificApplication.h"
#import "KMIconRegistry.h"
#if KMF_IS_ENGINE
#import "XRunningApplicationsList.h"
#endif
#if KMF_EDITOR_WINDOW
#import "AShowSpecificApplicationEditor.h"
#endif

#if KMF_EDITOR_WINDOW
void
AShowSpecificApplication::UpdateToDefaultValues()
{
	if ( !mApplication.HasValue() ) {
		mApplication = XApplicationIdentifier::FinderDefaultApplication();
	}
}
#endif

CFStringRef
AShowSpecificApplication::CopyActionDescriptionString() const
{
	NSString* theNameStr = mApplication.GetName();
	CFContainer<CFStringRef> theFormatStr = CFSTR("kmShowSpecificAppTitleFormat")->CopyLocalized();
	return CFString::CreateWithFormat( theFormatStr, theNameStr );
}

XIcon
AShowSpecificApplication::GetActionDescriptionXIcon() const
{
	return GetApplication().GetXIcon();
}

#if KMF_IS_ENGINE

float
AShowSpecificApplication::DoAction()
{
	mApplication.Show();
	
	return 20;
}

#endif

#if KMF_EDITOR_WINDOW

Class
AShowSpecificApplication::ActionController() const
{
	return [AShowSpecificApplicationEditor class];
}

#endif

#pragma mark streaming

void
AShowSpecificApplication::SaveToDictionary( CFMutableDictionaryRef dictionary ) const
{
	SafeCFPropertyListRef app = mApplication.CopyToPropertyList();
	dictionary->Set( CFSTR("Application"), app );
	CFRelease( app );
}

void
AShowSpecificApplication::InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException )
{
	SafeCFPropertyListRef app = (SafeCFPropertyListRef)dictionary->Get( CFSTR("Application") );
	XAssert( app );
	mApplication.LoadFromPropertyList( app );
}
