/*
 *  ASimulateKeystroke.h
 *  Keyboard Maestro
 *
 *  Created by Michael Kamprath on Sun Dec 16 2001.
 *  Copyright (c) 2004 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class ASimulateKeystroke
	:	public HBaseAction
{

private:

	CGKeyCode			mKeyCode;
	UInt32				mModifiers;
	Boolean				mReleaseAll;
	
#if KMF_IS_ENGINE
	EventTime			mActionTime;
#endif

public:
	
    ASimulateKeystroke();
	ASimulateKeystroke( const ASimulateKeystroke& inAction );
    virtual ~ASimulateKeystroke();

	virtual ASimulateKeystroke*		Clone() const { return new ASimulateKeystroke( *this ); }
	virtual ASimulateKeystroke*		Create() const { return new ASimulateKeystroke(); }
	
	virtual HBaseAction*			Merge( HBaseAction* action );

	void							SetSimulateKeystroke( const CGKeyCode& inKeyCode, const UInt32& inModifiers );
	CGKeyCode						GetKeyCode() const { return mKeyCode; }
	UInt32							GetModifiers() const { return mModifiers; }
	
	void							SetReleaseAll( const Boolean& inReleaseAll ) { mReleaseAll = inReleaseAll; }
	Boolean							GetReleaseAll() const { return mReleaseAll; }

	virtual	CFStringRef				CopyActionDescriptionString() const;
    virtual HActionType				GetActionType() const { return HActionType::kSimulateKeystroke; }

	virtual Boolean					IsKeystroke( UInt32 inModifiers, UInt32 inKeyCode ) const;

#if KMF_IS_ENGINE
    virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

