//
//  ASpeakText.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Wed 18 May 2011.
//  Copyright (c) 2011 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class ASpeakText
	:	public HBaseAction
{
private:
	
    CFContainer<CFStringRef>		mText;
    CFContainer<CFStringRef>		mVoice;

#if KMF_IS_ENGINE
	NSSpeechSynthesizer*			mSynthesizer;
#endif
	
public:
	
    ASpeakText();
	ASpeakText( const ASpeakText& inAction );
    virtual ~ASpeakText();

	virtual ASpeakText*				Clone() const { return new ASpeakText( *this ); }
	virtual ASpeakText*				Create() const { return new ASpeakText(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;
 	
	virtual HActionType				GetActionType() const { return HActionType::kSpeakText; }

    virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

	void							SetText( CFStringRef inString ) { mText = inString->Copy(); }
	CFStringRef						CopyText() const { return mText->Copy(); }
	NSString*						GetText() const { return mText->GetNS(); }
	
	void							SetVoice( CFStringRef inString ) { mVoice = inString->Copy(); }
	CFStringRef						CopyVoice() const { return mVoice->Copy(); }
	NSString*						GetVoice() const { return mVoice->GetNS(); }
		
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return kVeryLongDefaultTimeOutValue; }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
	virtual void					ActionAborted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif

};

