/*
 *  ASystemVolume.h
 *  Keyboard Maestro
 *
 *  Created by Peter N Lewis on Thu 27 Nov 2008.
 *  Copyright (c) 2008 Stairways Software. All rights reserved.
 */

#import "HBaseAction.h"

class ASystemVolume
	:	public HBaseAction
{
private:

	UInt32							mSystemVolume;

public:

    ASystemVolume();
	ASystemVolume( const ASystemVolume& inAction );
	virtual ~ASystemVolume() = default;

	virtual ASystemVolume*			Clone() const { return new ASystemVolume( *this ); }
	virtual ASystemVolume*			Create() const { return new ASystemVolume(); }
	
	virtual	CFStringRef				CopyActionDescriptionString() const;

    virtual HActionType				GetActionType() const { return HActionType::kSystemVolume; }

#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
#endif
	
	void							SetSystemVolume( UInt32 inSystemVolume ) { mSystemVolume = inSystemVolume; }
	UInt32							GetSystemVolume() const { return mSystemVolume; }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
};

