//
//  ATriggerByName.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 24 Sep 2009.
//  Copyright (c) 2009 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

@class TriggerByNameController;

class ATriggerByName : public HBaseAction
{
private:

	NSColor*						mColor;

#if KMF_IS_ENGINE
	TriggerByNameController*		mTriggerByNameController = nil;
#endif

public:
	ATriggerByName();
	ATriggerByName( const ATriggerByName& inAction );
	virtual ~ATriggerByName();

	virtual ATriggerByName*			Clone() const { return new ATriggerByName( *this ); }
	virtual ATriggerByName*			Create() const { return new ATriggerByName(); }
	
	virtual HActionType				GetActionType() const { return HActionType::kTriggerByName; }
	
	virtual Boolean					HasTimeOut() const { return true; }
	virtual EventTime				DefaultTimeOutPeriod() const { return 3*kEventDurationMinute; }
	
#if KMF_IS_ENGINE
	virtual float					DoAction();
	virtual Boolean					IsActionCompleted();
	virtual void					ActionAborted();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif
	
	NSColor*						GetColor() const { return mColor; }
	void							SetColor( NSColor* inColor );
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

