//
//  ATrimImage.h
//  Keyboard Maestro
//
//  Created by Peter N Lewis on Thu 3 May 2012.
//  Copyright (c) 2012 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"
#import "ClipboardTarget.h"

class ATrimImage
	:	public HBaseAction
{
private:

	ClipboardTarget					mTarget;

protected:

public:

    ATrimImage();
	ATrimImage( const ATrimImage& inAction );
	
    virtual ~ATrimImage();

	virtual ATrimImage*				Clone() const { return new ATrimImage( *this ); }
	virtual ATrimImage*				Create() const { return new ATrimImage(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kTrimImage; }
	
#if KMF_EDITOR_WINDOW
	virtual void					UpdateToDefaultValues() { mTarget.UpdateToDefaultValues(); }
#endif
	
	NSString*						GetGenericNamedClipboardUID() const { return mTarget.GetGenericNamedClipboardUID(); }
	void							SetGenericNamedClipboardUID( NSString* inUID ) { mTarget.SetGenericNamedClipboardUID( inUID ); }
	
#if KMF_IS_ENGINE
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionHTMLDescriptionString() const;
#endif

	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );

};

