//
//  AWindowSwitcher.h
//  Keyboard Maestro
//
//  Created by Michael Kamprath on Tue Jul 09 2002.
//  Copyright (c) 2004 Stairways Software. All rights reserved.
//

#import "HBaseAction.h"

class AWindowSwitcher
	:	public HBaseAction
{

private:

#if KMF_IS_ENGINE
	NSUUID*							mUUID = [NSUUID UUID];
#endif

	NSColor*						mColor;
	Boolean							mSwitcherUnderMouse = false;
	Boolean							mMouseRollover = true;
	Boolean							mSortAlphabetically = false;

public:

    AWindowSwitcher();
	AWindowSwitcher( const AWindowSwitcher& inAction ) = default;
    virtual ~AWindowSwitcher() = default;

	virtual AWindowSwitcher*		Clone() const { return new AWindowSwitcher( *this ); }
	virtual AWindowSwitcher*		Create() const { return new AWindowSwitcher(); }
	
    virtual HActionType				GetActionType() const { return HActionType::kWindowSwitcher; }

#if KMF_IS_ENGINE
    NSString*						GetUID() const { return [mUUID UUIDString]; }
    virtual float					DoAction();
#endif
#if KMF_EDITOR_WINDOW
	virtual Class					ActionController() const;
	virtual	NSString*				GetActionExtraHTML() const;
#endif

	NSColor*						GetSwitcherColor() const { return mColor; }
	void							SetSwitcherColor( NSColor* inColor );
	
	Boolean							GetSwitcherUnderMouse() const { return mSwitcherUnderMouse; }
	void							SetSwitcherUnderMouse( Boolean inSwitcherUnderMouse ) { mSwitcherUnderMouse = inSwitcherUnderMouse; }

	Boolean							GetMouseRollover() const { return mMouseRollover; }
	void							SetMouseRollover( Boolean inMouseRollover ) { mMouseRollover = inMouseRollover; }
	
	Boolean							GetSortAlphabetically() const { return mSortAlphabetically; }
	void							SetSortAlphabetically( Boolean inSortAlphabetically ) { mSortAlphabetically = inSortAlphabetically; }
	
	virtual void					SaveToDictionary( CFMutableDictionaryRef dictionary ) const;
	virtual void					InitializeFromDictionary( CFDictionaryRef dictionary ) throw ( XException );
	
};

